# 
# patch "apps/app_record.c"
#  from [5579258b34475b2044dab3c9648c1ec951e39413]
#    to [a46e4ff50b7665e5b4cde550cbb6a8662c76d4e1]
# 
===============================================
--- apps/app_record.c	5579258b34475b2044dab3c9648c1ec951e39413
+++ apps/app_record.c	a46e4ff50b7665e5b4cde550cbb6a8662c76d4e1
@@ -71,9 +71,8 @@
 	int gotsilence = 0;		/* did we timeout for silence? */
 	char silencestr[5];
 	char durationstr[8];
-	int maxduration = 0;		/* max duration of recording */
+	int maxduration = 0;		/* max duration of recording in milliseconds */
 	int gottimeout = 0;		/* did we timeout for maxduration exceeded? */
-	time_t timeout = 0;
 	char option[16];
 	int option_skip = 0;
 	int option_noanswer = 0;
@@ -150,7 +149,8 @@
 	durationstr[j] = '\0';
 
 	if (j > 0)
-		maxduration = atoi(durationstr);
+		/* Convert duration to milliseconds */
+		maxduration = atoi(durationstr) * 1000;
 
 	if (vdata[i] == '|')
 		i++;
@@ -228,13 +228,18 @@
 
 
 		if (s) {
-			if (maxduration > 0)
-				timeout = time(NULL) + (time_t)maxduration;
-
-			while (ast_waitfor(chan, -1) > -1) {
-				if (maxduration > 0 && time(NULL) > timeout) {
-					gottimeout = 1;
-					break;
+			int waitres;
+			
+			if (maxduration <= 0)
+				maxduration = -1;
+			
+			while ((waitres = ast_waitfor(chan, maxduration)) > -1) {
+				if (maxduration > 0) {
+					if (waitres == 0) {
+						gottimeout = 1;
+						break;
+					}
+					maxduration = waitres;
 				}
 
 				f = ast_read(chan);
